blob: 7413bd6682ee3913f250fc7653980a190aaa0d0c [file] [log] [blame]
garciadeblasd8bc5c32018-05-09 17:37:56 +02001#!/bin/bash
garciadeblasd8bc5c32018-05-09 17:37:56 +02002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
garciadeblas0bc87522021-10-20 22:16:17 +020014#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015
16function usage(){
garciadeblas0bc87522021-10-20 22:16:17 +020017 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020018 echo -e "usage: $0 [OPTIONS]"
19 echo -e "Install OSM from binaries or source code (by default, from binaries)"
20 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000021 echo -e " -h / --help: print this help"
22 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblasd8bc5c32018-05-09 17:37:56 +020023 echo -e " -r <repo>: use specified repository name for osm packages"
24 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
25 echo -e " -u <repo base>: use specified repository url for osm packages"
26 echo -e " -k <repo key>: use specified repository public key url"
27 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
28 echo -e " -b master (main dev branch)"
29 echo -e " -b v2.0 (v2.0 branch)"
30 echo -e " -b tags/v1.1.0 (a specific tag)"
31 echo -e " ..."
garciadeblas0bc87522021-10-20 22:16:17 +020032 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
garciadeblas325032a2023-04-13 18:07:44 +020033 echo -e " -s <namespace> namespace when installed using k8s, default is osm"
Mike Marchettib8420852018-09-13 13:45:06 -040034 echo -e " -H <VCA host> use specific juju host controller IP"
35 echo -e " -S <VCA secret> use VCA/juju secret key"
garciadeblasaa3ddf42019-04-04 19:04:32 +020036 echo -e " -P <VCA pubkey> use VCA/juju public key file"
Adam Israel5ddc97f2019-09-03 18:11:12 -040037 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
magnussonl1bbe9452020-02-25 13:43:17 +010038 echo -e " --pla: install the PLA module for placement support"
garciadeblas836354f2023-05-10 18:12:00 +020039 echo -e " --old-sa: install old Service Assurance framework (MON, POL); do not install Airflow and Pushgateway"
40 echo -e " --ng-sa: install new Service Assurance framework (Airflow, AlertManager and Pushgateway) (enabled by default)"
beierlmcca93642021-05-03 16:29:14 -040041 echo -e " -m <MODULE>: install OSM but only rebuild or pull the specified docker images (NG-UI, NBI, LCM, RO, MON, POL, PLA, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, NONE)"
garciadeblasfa3eb332022-11-15 14:11:56 +010042 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (k8s_monitor, ng-sa)"
Antonio Marsico75a38c72020-12-21 17:29:42 +010043 echo -e " -O <openrc file path/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020044 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
Antonio Marsico75a38c72020-12-21 17:29:42 +010045 echo -e " -f <path to SSH public key>: Public SSH key to use to deploy OSM to OpenStack"
46 echo -e " -F <path to cloud-init file>: Cloud-Init userdata file to deploy OSM to OpenStack"
garciadeblase990f662018-05-18 11:43:39 +020047 echo -e " -D <devops path> use local devops installation path"
Mike Marchettib8420852018-09-13 13:45:06 -040048 echo -e " -w <work dir> Location to store runtime installation"
Mike Marchetti13d76c82018-09-19 15:00:36 -040049 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020050 echo -e " -l: LXD cloud yaml file"
51 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020052 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000053 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
54 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
55 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas0bc87522021-10-20 22:16:17 +020056 echo -e " --debug: debug mode"
garciadeblas9a510862021-04-21 14:15:56 +020057 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
garciadeblas0bc87522021-10-20 22:16:17 +020058 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
David Garcia79f4f532020-04-07 12:59:34 +020059 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblasa3e26612018-05-30 17:58:55 +020060 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
Mike Marchettib8420852018-09-13 13:45:06 -040061 echo -e " --nojuju: do not juju, assumes already installed"
62 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
63 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
64 echo -e " --nohostclient: do not install the osmclient"
garciadeblase990f662018-05-18 11:43:39 +020065 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
66 echo -e " --source: install OSM from source code using the latest stable tag"
garciadeblasd8bc5c32018-05-09 17:37:56 +020067 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
Mike Marchettida8a9c42018-10-01 15:25:15 -040068 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
romeromonser599d5e22020-03-06 10:23:29 +010069 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020070 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblasd8bc5c32018-05-09 17:37:56 +020071 echo -e " --showopts: print chosen options and exit (only for debugging)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020072 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
73 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
74 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020075 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
aticig5d19ac22022-05-06 13:46:22 +030076 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020077 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020078 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
79 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
David Garcia4bd2bf02021-05-05 19:01:43 +020080 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020081 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
beierlmf2782c52020-11-05 17:04:05 -050082 echo -e " [--tag]: Docker image tag. (--charmed option)"
83 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
garciadeblas0bc87522021-10-20 22:16:17 +020084 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020085}
86
Mike Marchettib8420852018-09-13 13:45:06 -040087# takes a juju/accounts.yaml file and returns the password specific
Adam Israel8232e562018-11-21 16:47:45 -050088# for a controller. I wrote this using only bash tools to minimize
Mike Marchettib8420852018-09-13 13:45:06 -040089# additions of other packages
90function parse_juju_password {
garciadeblas0bc87522021-10-20 22:16:17 +020091 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
92 password_file="${HOME}/.local/share/juju/accounts.yaml"
93 local controller_name=$1
94 local s='[[:space:]]*' w='[a-zA-Z0-9_-]*' fs=$(echo @|tr @ '\034')
95 sed -ne "s|^\($s\):|\1|" \
96 -e "s|^\($s\)\($w\)$s:$s[\"']\(.*\)[\"']$s\$|\1$fs\2$fs\3|p" \
97 -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p" $password_file |
98 awk -F$fs -v controller=$controller_name '{
99 indent = length($1)/2;
100 vname[indent] = $2;
101 for (i in vname) {if (i > indent) {delete vname[i]}}
102 if (length($3) > 0) {
103 vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
104 if (match(vn,controller) && match($2,"password")) {
105 printf("%s",$3);
106 }
107 }
108 }'
109 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
110}
111
112function set_vca_variables() {
113 OSM_VCA_CLOUDNAME="lxd-cloud"
114 [ -n "$OSM_VCA_HOST" ] && OSM_VCA_CLOUDNAME="localhost"
115 if [ -z "$OSM_VCA_HOST" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200116 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_NAMESPACE"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
garciadeblas0bc87522021-10-20 22:16:17 +0200117 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
118 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
119 fi
120 if [ -z "$OSM_VCA_SECRET" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200121 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $OSM_NAMESPACE)
garciadeblas0bc87522021-10-20 22:16:17 +0200122 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $CONTROLLER_NAME)
123 [ -z "$OSM_VCA_SECRET" ] && FATAL "Cannot obtain juju secret"
124 fi
125 if [ -z "$OSM_VCA_PUBKEY" ]; then
126 OSM_VCA_PUBKEY=$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)
127 [ -z "$OSM_VCA_PUBKEY" ] && FATAL "Cannot obtain juju public key"
128 fi
129 if [ -z "$OSM_VCA_CACERT" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200130 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $OSM_NAMESPACE '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
garciadeblas0bc87522021-10-20 22:16:17 +0200131 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $CONTROLLER_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
132 [ -z "$OSM_VCA_CACERT" ] && FATAL "Cannot obtain juju CA certificate"
133 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400134}
135
Benjamin Diazba2cca92018-11-08 21:07:15 -0300136function generate_secret() {
garciadeblas0bc87522021-10-20 22:16:17 +0200137 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Benjamin Diazba2cca92018-11-08 21:07:15 -0300138 head /dev/urandom | tr -dc A-Za-z0-9 | head -c 32
garciadeblas0bc87522021-10-20 22:16:17 +0200139 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
calvinosanc10c82da02020-08-17 11:45:15 +0200140}
141
beierlm2ce2b002021-12-07 16:02:22 -0500142function check_packages() {
143 NEEDED_PACKAGES="$1"
144 echo -e "Checking required packages: ${NEEDED_PACKAGES}"
145 for PACKAGE in ${NEEDED_PACKAGES} ; do
garciadeblas835088e2022-01-28 11:25:18 +0100146 dpkg -L ${PACKAGE}
beierlm2ce2b002021-12-07 16:02:22 -0500147 if [ $? -ne 0 ]; then
garciadeblas835088e2022-01-28 11:25:18 +0100148 echo -e "Package ${PACKAGE} is not installed."
149 echo -e "Updating apt-cache ..."
beierlm2ce2b002021-12-07 16:02:22 -0500150 sudo apt-get update
garciadeblas835088e2022-01-28 11:25:18 +0100151 echo -e "Installing ${PACKAGE} ..."
beierlm2ce2b002021-12-07 16:02:22 -0500152 sudo apt-get install -y ${PACKAGE} || FATAL "failed to install ${PACKAGE}"
153 fi
154 done
155 echo -e "Required packages are present: ${NEEDED_PACKAGES}"
156}
157
garciadeblasd8bc5c32018-05-09 17:37:56 +0200158function ask_user(){
159 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
160 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
161 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
garciadeblas0bc87522021-10-20 22:16:17 +0200162 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200163 read -e -p "$1" USER_CONFIRMATION
164 while true ; do
165 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
166 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
167 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
168 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
169 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
170 done
garciadeblas0bc87522021-10-20 22:16:17 +0200171 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200172}
173
garciadeblasd8bc5c32018-05-09 17:37:56 +0200174function install_osmclient(){
garciadeblas0bc87522021-10-20 22:16:17 +0200175 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200176 CLIENT_RELEASE=${RELEASE#"-R "}
177 CLIENT_REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
178 CLIENT_REPOSITORY=${REPOSITORY#"-r "}
garciadeblasd8bc5c32018-05-09 17:37:56 +0200179 CLIENT_REPOSITORY_BASE=${REPOSITORY_BASE#"-u "}
180 key_location=$CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE/$CLIENT_REPOSITORY_KEY
garciadeblas0bc87522021-10-20 22:16:17 +0200181 curl $key_location | sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add -
garciadeblas078f5982019-11-27 15:06:06 +0100182 sudo add-apt-repository -y "deb [arch=amd64] $CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE $CLIENT_REPOSITORY osmclient IM"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200183 sudo apt-get update
garciadeblas078f5982019-11-27 15:06:06 +0100184 sudo apt-get install -y python3-pip
185 sudo -H LC_ALL=C python3 -m pip install -U pip
garciadeblasa9954892020-01-22 16:05:05 +0100186 sudo -H LC_ALL=C python3 -m pip install -U python-magic pyangbind verboselogs
garciadeblasda89ee72019-11-28 02:19:59 +0100187 sudo apt-get install -y python3-osm-im python3-osmclient
beierlm920d7562021-04-21 05:13:53 -0400188 if [ -f /usr/lib/python3/dist-packages/osm_im/requirements.txt ]; then
beierlm021b3072021-04-27 14:33:24 -0400189 python3 -m pip install -r /usr/lib/python3/dist-packages/osm_im/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400190 fi
191 if [ -f /usr/lib/python3/dist-packages/osmclient/requirements.txt ]; then
garciadeblas56005542022-08-29 14:56:02 +0200192 sudo apt-get install -y libcurl4-openssl-dev libssl-dev libmagic1
beierlm021b3072021-04-27 14:33:24 -0400193 python3 -m pip install -r /usr/lib/python3/dist-packages/osmclient/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400194 fi
garciadeblasd8bc5c32018-05-09 17:37:56 +0200195 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_HOSTNAME=`lxc list | awk '($2=="SO-ub"){print $6}'`
196 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_RO_HOSTNAME=`lxc list | awk '($2=="RO"){print $6}'`
garciadeblasd8bc5c32018-05-09 17:37:56 +0200197 echo -e "\nOSM client installed"
garciadeblasc3226982018-11-27 11:32:47 +0100198 if [ -z "$INSTALL_LIGHTWEIGHT" ]; then
199 echo -e "You might be interested in adding the following OSM client env variables to your .bashrc file:"
200 echo " export OSM_HOSTNAME=${OSM_HOSTNAME}"
201 echo " export OSM_RO_HOSTNAME=${OSM_RO_HOSTNAME}"
202 else
203 echo -e "OSM client assumes that OSM host is running in localhost (127.0.0.1)."
204 echo -e "In case you want to interact with a different OSM host, you will have to configure this env variable in your .bashrc file:"
205 echo " export OSM_HOSTNAME=<OSM_host>"
206 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200207 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200208 return 0
209}
210
garciadeblas453d4582020-12-16 19:03:10 +0100211function docker_login() {
garciadeblas0bc87522021-10-20 22:16:17 +0200212 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100213 echo "Docker login"
garciadeblas0bc87522021-10-20 22:16:17 +0200214 [ -z "${DEBUG_INSTALL}" ] || DEBUG "Docker registry user: ${DOCKER_REGISTRY_USER}"
215 sg docker -c "docker login -u ${DOCKER_REGISTRY_USER} -p ${DOCKER_REGISTRY_PASSWORD} --password-stdin"
216 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100217}
218
garciadeblas53b217f2023-05-04 17:57:47 +0200219function pull_docker_images() {
garciadeblas0bc87522021-10-20 22:16:17 +0200220 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas53b217f2023-05-04 17:57:47 +0200221 echo "Pulling docker images"
garciadeblas453d4582020-12-16 19:03:10 +0100222 [ -n "${DOCKER_REGISTRY_URL}" ] && docker_login
Michael Marchettiee374142018-08-02 22:47:16 +0200223
garciadeblas53b217f2023-05-04 17:57:47 +0200224 echo "Pulling non-OSM docker images"
garciadeblas0e596bc2018-05-28 16:04:42 +0200225 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q KAFKA ; then
226 sg docker -c "docker pull wurstmeister/zookeeper" || FATAL "cannot get zookeeper docker image"
Benjamin Diazaa0af712018-10-04 14:02:34 -0300227 sg docker -c "docker pull wurstmeister/kafka:${KAFKA_TAG}" || FATAL "cannot get kafka docker image"
garciadeblas0e596bc2018-05-28 16:04:42 +0200228 fi
Mike Marchettida8a9c42018-10-01 15:25:15 -0400229
lavado60216242018-10-10 23:44:28 +0200230 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS ; then
231 sg docker -c "docker pull prom/prometheus:${PROMETHEUS_TAG}" || FATAL "cannot get prometheus docker image"
232 fi
233
garciadeblasfc5bb142019-12-10 10:49:12 +0100234 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS-CADVISOR ; then
235 sg docker -c "docker pull google/cadvisor:${PROMETHEUS_CADVISOR_TAG}" || FATAL "cannot get prometheus cadvisor docker image"
236 fi
237
lavado6ad812e2019-11-29 10:58:58 -0500238 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q GRAFANA ; then
239 sg docker -c "docker pull grafana/grafana:${GRAFANA_TAG}" || FATAL "cannot get grafana docker image"
garciadeblas0ab16612022-02-22 14:23:57 +0100240 sg docker -c "docker pull kiwigrid/k8s-sidecar:${KIWIGRID_K8S_SIDECAR_TAG}" || FATAL "cannot get kiwigrid k8s-sidecar docker image"
garciadeblasfc5bb142019-12-10 10:49:12 +0100241 fi
lavado6ad812e2019-11-29 10:58:58 -0500242
garciadeblas4a83e6e2018-12-04 14:55:09 +0100243 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NBI || echo $TO_REBUILD | grep -q KEYSTONE-DB ; then
lavado9a8df7c2018-10-24 09:35:34 -0500244 sg docker -c "docker pull mariadb:${KEYSTONEDB_TAG}" || FATAL "cannot get keystone-db docker image"
245 fi
246
garciadeblas4a83e6e2018-12-04 14:55:09 +0100247 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q RO ; then
248 sg docker -c "docker pull mysql:5" || FATAL "cannot get mysql docker image"
249 fi
250
garciadeblas53b217f2023-05-04 17:57:47 +0200251 echo "Pulling OSM docker images"
252 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA osmclient Airflow; do
253 module_lower=${module,,}
254 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
255 continue
256 fi
257 module_tag="${OSM_DOCKER_TAG}"
258 if [ -n "${MODULE_DOCKER_TAG}" ] && echo $TO_REBUILD | grep -q $module ; then
259 module_tag="${MODULE_DOCKER_TAG}"
260 fi
261 echo "Pulling ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag} docker image"
262 sg docker -c "docker pull ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag}" || FATAL "cannot pull $module docker image"
263 done
264
265 echo "Finished pulling docker images"
266 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
267}
268
269function generate_docker_images() {
270 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
271 echo "Generating docker images"
272 _build_from=$COMMIT_ID
273 [ -z "$_build_from" ] && _build_from="latest"
274 echo "OSM Docker images generated from $_build_from"
275 LWTEMPDIR="$(mktemp -d -q --tmpdir "installosmlight.XXXXXX")"
276 trap 'rm -rf "${LWTEMPDIR}"' EXIT
277 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA; do
278 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q ${module} ; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000279 module_lower=${module,,}
garciadeblas7f1e1042020-11-30 14:07:03 +0000280 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
281 continue
282 fi
garciadeblas53b217f2023-05-04 17:57:47 +0200283 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/$module
284 git -C ${LWTEMPDIR}/${module} checkout ${COMMIT_ID}
285 sg docker -c "docker build ${LWTEMPDIR}/${module} -f ${LWTEMPDIR}/${module}/docker/Dockerfile -t ${DOCKER_USER}/${module_lower} --no-cache" || FATAL "cannot build ${module} docker image"
vijaynag4b57d462020-06-08 14:23:10 +0000286 fi
garciadeblas53b217f2023-05-04 17:57:47 +0200287 done
288 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q osmclient; then
289 BUILD_ARGS+=(--build-arg REPOSITORY="$REPOSITORY")
290 BUILD_ARGS+=(--build-arg RELEASE="$RELEASE")
291 BUILD_ARGS+=(--build-arg REPOSITORY_KEY="$REPOSITORY_KEY")
292 BUILD_ARGS+=(--build-arg REPOSITORY_BASE="$REPOSITORY_BASE")
293 sg docker -c "docker build -t ${DOCKER_USER}/osmclient ${BUILD_ARGS[@]} -f $OSM_DEVOPS/docker/osmclient ."
Mike Marchettib8420852018-09-13 13:45:06 -0400294 fi
garciadeblas53b217f2023-05-04 17:57:47 +0200295 echo "Finished generation of docker images"
garciadeblas0bc87522021-10-20 22:16:17 +0200296 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200297}
298
garciadeblas5b857d32018-05-24 18:37:58 +0200299function cmp_overwrite() {
garciadeblas0bc87522021-10-20 22:16:17 +0200300 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas5b857d32018-05-24 18:37:58 +0200301 file1="$1"
302 file2="$2"
303 if ! $(cmp "${file1}" "${file2}" >/dev/null 2>&1); then
304 if [ -f "${file2}" ]; then
Mike Marchettib8420852018-09-13 13:45:06 -0400305 ask_user "The file ${file2} already exists. Overwrite (y/N)? " n && cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200306 else
Mike Marchettib8420852018-09-13 13:45:06 -0400307 cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200308 fi
309 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200310 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400311}
312
313function generate_k8s_manifest_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200314 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
beierlma4a37f72020-06-26 12:55:01 -0400315 #Kubernetes resources
garciadeblas0bc87522021-10-20 22:16:17 +0200316 sudo cp -bR ${OSM_DEVOPS}/installers/docker/osm_pods $OSM_DOCKER_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200317 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400318}
319
garciadeblasd8bc5c32018-05-09 17:37:56 +0200320function generate_docker_env_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200321 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200322 echo "Doing a backup of existing env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200323 sudo cp $OSM_DOCKER_WORK_DIR/keystone-db.env{,~}
324 sudo cp $OSM_DOCKER_WORK_DIR/keystone.env{,~}
325 sudo cp $OSM_DOCKER_WORK_DIR/lcm.env{,~}
326 sudo cp $OSM_DOCKER_WORK_DIR/mon.env{,~}
327 sudo cp $OSM_DOCKER_WORK_DIR/nbi.env{,~}
328 sudo cp $OSM_DOCKER_WORK_DIR/pol.env{,~}
329 sudo cp $OSM_DOCKER_WORK_DIR/ro-db.env{,~}
330 sudo cp $OSM_DOCKER_WORK_DIR/ro.env{,~}
garciadeblas7b53d262022-11-04 23:18:48 +0100331 if [ -n "${INSTALL_NGSA}" ]; then
332 sudo cp $OSM_DOCKER_WORK_DIR/ngsa.env{,~}
garciadeblasbacdfa82023-04-04 10:52:46 +0200333 sudo cp $OSM_DOCKER_WORK_DIR/webhook-translator.env{,~}
garciadeblas7b53d262022-11-04 23:18:48 +0100334 fi
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200335
garciadeblasd8bc5c32018-05-09 17:37:56 +0200336 echo "Generating docker env files"
Benjamin Diazba2cca92018-11-08 21:07:15 -0300337 # LCM
338 if [ ! -f $OSM_DOCKER_WORK_DIR/lcm.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200339 echo "OSMLCM_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300340 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400341
Benjamin Diazba2cca92018-11-08 21:07:15 -0300342 if ! grep -Fq "OSMLCM_VCA_HOST" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200343 echo "OSMLCM_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300344 else
garciadeblas0bc87522021-10-20 22:16:17 +0200345 sudo sed -i "s|OSMLCM_VCA_HOST.*|OSMLCM_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300346 fi
347
348 if ! grep -Fq "OSMLCM_VCA_SECRET" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200349 echo "OSMLCM_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300350 else
garciadeblas0bc87522021-10-20 22:16:17 +0200351 sudo sed -i "s|OSMLCM_VCA_SECRET.*|OSMLCM_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300352 fi
353
garciadeblasaa3ddf42019-04-04 19:04:32 +0200354 if ! grep -Fq "OSMLCM_VCA_PUBKEY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200355 echo "OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200356 else
garciadeblas0bc87522021-10-20 22:16:17 +0200357 sudo sed -i "s|OSMLCM_VCA_PUBKEY.*|OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200358 fi
359
Adam Israelbe7676a2019-10-02 16:10:53 -0400360 if ! grep -Fq "OSMLCM_VCA_CACERT" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200361 echo "OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400362 else
garciadeblas0bc87522021-10-20 22:16:17 +0200363 sudo sed -i "s|OSMLCM_VCA_CACERT.*|OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400364 fi
Benjamin Diazba2cca92018-11-08 21:07:15 -0300365
David Garcia6cbfee12020-10-23 10:40:20 +0200366 if [ -n "$OSM_VCA_APIPROXY" ]; then
367 if ! grep -Fq "OSMLCM_VCA_APIPROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200368 echo "OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200369 else
garciadeblas0bc87522021-10-20 22:16:17 +0200370 sudo sed -i "s|OSMLCM_VCA_APIPROXY.*|OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200371 fi
Adam Israel5ddc97f2019-09-03 18:11:12 -0400372 fi
373
garciadeblasa2e41842019-12-18 11:05:24 +0100374 if ! grep -Fq "OSMLCM_VCA_ENABLEOSUPGRADE" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200375 echo "# OSMLCM_VCA_ENABLEOSUPGRADE=false" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100376 fi
377
378 if ! grep -Fq "OSMLCM_VCA_APTMIRROR" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200379 echo "# OSMLCM_VCA_APTMIRROR=http://archive.ubuntu.com/ubuntu/" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100380 fi
381
David Garcia79f4f532020-04-07 12:59:34 +0200382 if ! grep -Fq "OSMLCM_VCA_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200383 echo "OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200384 else
garciadeblas0bc87522021-10-20 22:16:17 +0200385 sudo sed -i "s|OSMLCM_VCA_CLOUD.*|OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200386 fi
387
beierlma4a37f72020-06-26 12:55:01 -0400388 if ! grep -Fq "OSMLCM_VCA_K8S_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200389 echo "OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400390 else
garciadeblas0bc87522021-10-20 22:16:17 +0200391 sudo sed -i "s|OSMLCM_VCA_K8S_CLOUD.*|OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400392 fi
garciadeblasfa3eb332022-11-15 14:11:56 +0100393 if [ -n "${OSM_BEHIND_PROXY}" ]; then
394 if ! grep -Fq "HTTP_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
395 echo "HTTP_PROXY=${HTTP_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
396 else
397 sudo sed -i "s|HTTP_PROXY.*|HTTP_PROXY=${HTTP_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
398 fi
399 if ! grep -Fq "HTTPS_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
400 echo "HTTPS_PROXY=${HTTPS_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
401 else
402 sudo sed -i "s|HTTPS_PROXY.*|HTTPS_PROXY=${HTTPS_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
403 fi
404 if ! grep -Fq "NO_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
405 echo "NO_PROXY=${NO_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
406 else
407 sudo sed -i "s|NO_PROXY.*|NO_PROXY=${NO_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
408 fi
409 fi
beierlma4a37f72020-06-26 12:55:01 -0400410
Benjamin Diazba2cca92018-11-08 21:07:15 -0300411 # RO
412 MYSQL_ROOT_PASSWORD=$(generate_secret)
Mike Marchettib8420852018-09-13 13:45:06 -0400413 if [ ! -f $OSM_DOCKER_WORK_DIR/ro-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200414 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro-db.env
garciadeblas5b857d32018-05-24 18:37:58 +0200415 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400416 if [ ! -f $OSM_DOCKER_WORK_DIR/ro.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200417 echo "RO_DB_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro.env
garciadeblas5b857d32018-05-24 18:37:58 +0200418 fi
tierno9ec1fe92020-11-25 13:16:51 +0000419 if ! grep -Fq "OSMRO_DATABASE_COMMONKEY" $OSM_DOCKER_WORK_DIR/ro.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200420 echo "OSMRO_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ro.env
tierno9ec1fe92020-11-25 13:16:51 +0000421 fi
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100422
Benjamin Diazba2cca92018-11-08 21:07:15 -0300423 # Keystone
Benjamin Diazba2cca92018-11-08 21:07:15 -0300424 KEYSTONE_DB_PASSWORD=$(generate_secret)
Eduardo Sousac50ed8f2019-04-08 17:17:54 +0100425 SERVICE_PASSWORD=$(generate_secret)
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100426 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200427 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone-db.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100428 fi
429 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200430 echo "ROOT_DB_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone.env
431 echo "KEYSTONE_DB_PASSWORD=${KEYSTONE_DB_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
432 echo "SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100433 fi
434
Benjamin Diazba2cca92018-11-08 21:07:15 -0300435 # NBI
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100436 if [ ! -f $OSM_DOCKER_WORK_DIR/nbi.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200437 echo "OSMNBI_AUTHENTICATION_SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/nbi.env
438 echo "OSMNBI_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/nbi.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100439 fi
440
Benjamin Diazba2cca92018-11-08 21:07:15 -0300441 # MON
442 if [ ! -f $OSM_DOCKER_WORK_DIR/mon.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200443 echo "OSMMON_KEYSTONE_SERVICE_PASSWORD=${SERVICE_PASSWORD}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
444 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
445 echo "OSMMON_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/mon" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300446 fi
447
448 if ! grep -Fq "OS_NOTIFIER_URI" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100449 echo "OS_NOTIFIER_URI=http://${OSM_DEFAULT_IP}:8662" |sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300450 else
garciadeblas45ab04c2022-11-25 10:59:03 +0100451 sudo sed -i "s|OS_NOTIFIER_URI.*|OS_NOTIFIER_URI=http://$OSM_DEFAULT_IP:8662|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300452 fi
453
454 if ! grep -Fq "OSMMON_VCA_HOST" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200455 echo "OSMMON_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300456 else
garciadeblas0bc87522021-10-20 22:16:17 +0200457 sudo sed -i "s|OSMMON_VCA_HOST.*|OSMMON_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300458 fi
459
460 if ! grep -Fq "OSMMON_VCA_SECRET" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200461 echo "OSMMON_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300462 else
garciadeblas0bc87522021-10-20 22:16:17 +0200463 sudo sed -i "s|OSMMON_VCA_SECRET.*|OSMMON_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300464 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400465
Adam Israel6d8adf32019-12-05 15:46:54 -0500466 if ! grep -Fq "OSMMON_VCA_CACERT" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200467 echo "OSMMON_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500468 else
garciadeblas0bc87522021-10-20 22:16:17 +0200469 sudo sed -i "s|OSMMON_VCA_CACERT.*|OSMMON_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500470 fi
471
Benjamin Diaz04560882019-02-26 17:25:07 -0300472 # POL
473 if [ ! -f $OSM_DOCKER_WORK_DIR/pol.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200474 echo "OSMPOL_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/pol" | sudo tee -a $OSM_DOCKER_WORK_DIR/pol.env
Benjamin Diaz04560882019-02-26 17:25:07 -0300475 fi
476
garciadeblas7b53d262022-11-04 23:18:48 +0100477 # NG-SA
478 if [ -n "${INSTALL_NGSA}" ] && [ ! -f $OSM_DOCKER_WORK_DIR/ngsa.env ]; then
479 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ngsa.env
480 fi
481
garciadeblasbacdfa82023-04-04 10:52:46 +0200482 # Webhook-translator
483 if [ -n "${INSTALL_NGSA}" ] && [ ! -f $OSM_DOCKER_WORK_DIR/webhook-translator.env ]; then
484 echo "AIRFLOW_HOST=airflow-webserver" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
485 echo "AIRFLOW_PORT=8080" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
486 echo "AIRFLOW_USER=admin" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
487 echo "AIRFLOW_PASS=admin" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
488 fi
489
garciadeblasd8bc5c32018-05-09 17:37:56 +0200490 echo "Finished generation of docker env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200491 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530492}
493
494#creates secrets from env files which will be used by containers
495function kube_secrets(){
garciadeblas0bc87522021-10-20 22:16:17 +0200496 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas325032a2023-04-13 18:07:44 +0200497 kubectl create ns $OSM_NAMESPACE
498 kubectl create secret generic lcm-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/lcm.env
499 kubectl create secret generic mon-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/mon.env
500 kubectl create secret generic nbi-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/nbi.env
501 kubectl create secret generic ro-db-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/ro-db.env
502 kubectl create secret generic ro-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/ro.env
503 kubectl create secret generic keystone-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/keystone.env
504 kubectl create secret generic pol-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/pol.env
garciadeblas7b53d262022-11-04 23:18:48 +0100505 if [ -n "${INSTALL_NGSA}" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200506 kubectl create secret generic ngsa-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/ngsa.env
507 kubectl create secret generic webhook-translator-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/webhook-translator.env
garciadeblas7b53d262022-11-04 23:18:48 +0100508 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200509 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasf6ed60c2020-07-08 14:30:29 +0000510}
511
512#deploys osm pods and services
513function deploy_osm_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200514 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas325032a2023-04-13 18:07:44 +0200515 kubectl apply -n $OSM_NAMESPACE -f $OSM_K8S_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200516 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530517}
518
David Garciaa1376012020-10-19 15:42:42 +0200519#deploy charmed services
520function deploy_charmed_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200521 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas325032a2023-04-13 18:07:44 +0200522 juju add-model $OSM_NAMESPACE $OSM_VCA_K8S_CLOUDNAME
523 juju deploy ch:mongodb-k8s -m $OSM_NAMESPACE
garciadeblas0bc87522021-10-20 22:16:17 +0200524 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
David Garciaa1376012020-10-19 15:42:42 +0200525}
526
magnussonl1bbe9452020-02-25 13:43:17 +0100527function deploy_osm_pla_service() {
garciadeblas0bc87522021-10-20 22:16:17 +0200528 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
magnussonl1bbe9452020-02-25 13:43:17 +0100529 # corresponding to deploy_osm_services
garciadeblas325032a2023-04-13 18:07:44 +0200530 kubectl apply -n $OSM_NAMESPACE -f $OSM_DOCKER_WORK_DIR/osm_pla
garciadeblas0bc87522021-10-20 22:16:17 +0200531 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonser599d5e22020-03-06 10:23:29 +0100532}
533
garciadeblas7b53d262022-11-04 23:18:48 +0100534function install_osm_ngsa_service() {
535 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas37630992023-05-09 13:33:22 +0200536 NGSA_OPTS="-d ${OSM_HELM_WORK_DIR} -D ${OSM_DEVOPS} -t ${OSM_DOCKER_TAG} -U ${DOCKER_USER} ${DEBUG_INSTALL}"
537 [ -n "${DOCKER_REGISTRY_URL}" ] && NGSA_OPTS="${NGSA_OPTS} -r ${DOCKER_REGISTRY_URL}"
538 $OSM_DEVOPS/installers/install_ngsa.sh ${NGSA_OPTS} || \
garciadeblas7b53d262022-11-04 23:18:48 +0100539 FATAL_TRACK install_osm_ngsa_service "install_ngsa.sh failed"
540 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
541}
542
vijaynag8339ed22019-07-25 17:10:58 +0530543function parse_yaml() {
garciadeblas0bc87522021-10-20 22:16:17 +0200544 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530545 TAG=$1
garciadeblas7f1e1042020-11-30 14:07:03 +0000546 shift
547 services=$@
548 for module in $services; do
549 if [ "$module" == "pla" ]; then
550 if [ -n "$INSTALL_PLA" ]; then
garciadeblas7b53d262022-11-04 23:18:48 +0100551 echo "Updating K8s manifest file from opensourcemano\/pla:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/pla:${TAG}"
garciadeblas0bc87522021-10-20 22:16:17 +0200552 sudo sed -i "s#opensourcemano/pla:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/pla:${TAG}#g" ${OSM_DOCKER_WORK_DIR}/osm_pla/pla.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000553 fi
554 else
garciadeblas7b53d262022-11-04 23:18:48 +0100555 image=${module}
556 if [ "$module" == "ng-prometheus" ]; then
557 image="prometheus"
garciadeblas0e49b4a2023-04-17 12:38:17 +0200558 elif [ "$module" == "ng-mon" ]; then
559 image="mon"
garciadeblas7b53d262022-11-04 23:18:48 +0100560 fi
561 echo "Updating K8s manifest file from opensourcemano\/${image}:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/${image}:${TAG}"
562 sudo sed -i "s#opensourcemano/${image}:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/${image}:${TAG}#g" ${OSM_K8S_WORK_DIR}/${module}.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000563 fi
vijaynag8339ed22019-07-25 17:10:58 +0530564 done
garciadeblas0bc87522021-10-20 22:16:17 +0200565 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas7f1e1042020-11-30 14:07:03 +0000566}
567
568function update_manifest_files() {
garciadeblas0e49b4a2023-04-17 12:38:17 +0200569 osm_services="nbi lcm ro pol mon ng-mon ng-ui keystone pla prometheus ng-prometheus"
garciadeblas7f1e1042020-11-30 14:07:03 +0000570 list_of_services=""
571 for module in $osm_services; do
572 module_upper="${module^^}"
garciadeblas7f1e1042020-11-30 14:07:03 +0000573 if ! echo $TO_REBUILD | grep -q $module_upper ; then
574 list_of_services="$list_of_services $module"
575 fi
576 done
garciadeblas89c5f552022-11-24 20:16:57 +0100577 if [ ! "$OSM_DOCKER_TAG" == "13" ]; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000578 parse_yaml $OSM_DOCKER_TAG $list_of_services
579 fi
580 if [ -n "$MODULE_DOCKER_TAG" ]; then
581 parse_yaml $MODULE_DOCKER_TAG $list_of_services_to_rebuild
582 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100583 # The manifest for prometheus is prometheus.yaml or ng-prometheus.yaml, depending on the installation option
garciadeblas0e49b4a2023-04-17 12:38:17 +0200584 # If NG-SA is installed, it will include ng-mon (only mon-dashboarder), ng-prometheus and webhook translator. It won't include pol, mon and prometheus
garciadeblas7b53d262022-11-04 23:18:48 +0100585 if [ -n "$INSTALL_NGSA" ]; then
586 sudo rm -f ${OSM_K8S_WORK_DIR}/prometheus.yaml
garciadeblas0e49b4a2023-04-17 12:38:17 +0200587 sudo rm -f ${OSM_K8S_WORK_DIR}/mon.yaml
588 sudo rm -f ${OSM_K8S_WORK_DIR}/pol.yaml
garciadeblas7b53d262022-11-04 23:18:48 +0100589 else
garciadeblas0e49b4a2023-04-17 12:38:17 +0200590 sudo rm -f ${OSM_K8S_WORK_DIR}/ng-mon.yaml
garciadeblas7b53d262022-11-04 23:18:48 +0100591 sudo rm -f ${OSM_K8S_WORK_DIR}/ng-prometheus.yaml
garciadeblasbacdfa82023-04-04 10:52:46 +0200592 sudo rm -f ${OSM_K8S_WORK_DIR}/webhook-translator.yaml
garciadeblas7b53d262022-11-04 23:18:48 +0100593 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200594 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530595}
596
597function namespace_vol() {
garciadeblas0bc87522021-10-20 22:16:17 +0200598 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas7b53d262022-11-04 23:18:48 +0100599 # List of services with a volume mounted in path /var/lib/osm
600 osm_services="mysql"
vijaynag8339ed22019-07-25 17:10:58 +0530601 for osm in $osm_services; do
garciadeblas7b53d262022-11-04 23:18:48 +0100602 if [ -f "$OSM_K8S_WORK_DIR/$osm.yaml" ] ; then
603 sudo sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_K8S_WORK_DIR/$osm.yaml
604 fi
vijaynag8339ed22019-07-25 17:10:58 +0530605 done
garciadeblas0bc87522021-10-20 22:16:17 +0200606 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas6c66abf2018-05-16 14:46:19 +0200607}
608
garciadeblase92a18d2020-07-03 16:24:23 +0000609function add_local_k8scluster() {
garciadeblas0bc87522021-10-20 22:16:17 +0200610 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblase92a18d2020-07-03 16:24:23 +0000611 /usr/bin/osm --all-projects vim-create \
612 --name _system-osm-vim \
613 --account_type dummy \
614 --auth_url http://dummy \
615 --user osm --password osm --tenant osm \
616 --description "dummy" \
617 --config '{management_network_name: mgmt}'
618 /usr/bin/osm --all-projects k8scluster-add \
619 --creds ${HOME}/.kube/config \
620 --vim _system-osm-vim \
621 --k8s-nets '{"net1": null}' \
622 --version '1.15' \
623 --description "OSM Internal Cluster" \
624 _system-osm-k8s
garciadeblas0bc87522021-10-20 22:16:17 +0200625 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblase92a18d2020-07-03 16:24:23 +0000626}
627
garciadeblas0bc87522021-10-20 22:16:17 +0200628function configure_apt_proxy() {
629 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
630 OSM_APT_PROXY=$1
631 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
632 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
633 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
634 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
635Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
636EOF"
637 else
638 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
639 fi
640 sudo apt-get update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas4d89c372021-11-25 11:57:18 +0100641 track prereq apt_proxy_configured_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200642 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
643}
644
garciadeblasfa3eb332022-11-15 14:11:56 +0100645function ask_proceed() {
garciadeblas0bc87522021-10-20 22:16:17 +0200646 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasadcf95e2022-01-28 17:15:39 +0100647
garciadeblas0bc87522021-10-20 22:16:17 +0200648 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will do the following
649 1. Install and configure LXD
650 2. Install juju
651 3. Install docker CE
652 4. Disable swap space
653 5. Install and initialize Kubernetes
654 as pre-requirements.
655 Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
garciadeblasfa3eb332022-11-15 14:11:56 +0100656
657 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
658}
659
660function check_osm_behind_proxy() {
661 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
662
663 export OSM_BEHIND_PROXY=""
664 export OSM_PROXY_ENV_VARIABLES=""
665 [ -n "${http_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "http_proxy=${http_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} http_proxy"
666 [ -n "${https_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${https_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} https_proxy"
667 [ -n "${HTTP_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "HTTP_PROXY=${HTTP_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTP_PROXY"
668 [ -n "${HTTPS_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${HTTPS_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTPS_PROXY"
669 [ -n "${no_proxy}" ] && echo "no_proxy=${no_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} no_proxy"
670 [ -n "${NO_PROXY}" ] && echo "NO_PROXY=${NO_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} NO_PROXY"
671
672 echo "OSM_BEHIND_PROXY=${OSM_BEHIND_PROXY}"
673 echo "OSM_PROXY_ENV_VARIABLES=${OSM_PROXY_ENV_VARIABLES}"
674
675 if [ -n "${OSM_BEHIND_PROXY}" ]; then
676 [ -z "$ASSUME_YES" ] && ! ask_user "
677The following env variables have been found for the current user:
678${OSM_PROXY_ENV_VARIABLES}.
679
680This suggests that this machine is behind a proxy and a special configuration is required.
681The installer will install Docker CE, LXD and Juju to work behind a proxy using those
682env variables.
683
684Take into account that the installer uses apt, curl, wget, docker, lxd, juju and snap.
685Depending on the program, the env variables to work behind a proxy might be different
686(e.g. http_proxy vs HTTP_PROXY).
687
688For that reason, it is strongly recommended that at least http_proxy, https_proxy, HTTP_PROXY
689and HTTPS_PROXY are defined.
690
691Finally, some of the programs (apt, snap) those programs are run as sudoer, requiring that
692those env variables are also set for root user. If you are not sure whether those variables
693are configured for the root user, you can stop the installation now.
694
695Do you want to proceed with the installation (Y/n)? " y && echo "Cancelled!" && exit 1
696 else
697 echo "This machine is not behind a proxy"
698 fi
699
700 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
701}
702
703function find_devops_folder() {
704 if [ -z "$OSM_DEVOPS" ]; then
705 if [ -n "$TEST_INSTALLER" ]; then
706 echo -e "\nUsing local devops repo for OSM installation"
707 OSM_DEVOPS="$(dirname $(realpath $(dirname $0)))"
708 else
709 echo -e "\nCreating temporary dir for OSM installation"
710 OSM_DEVOPS="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
711 trap 'rm -rf "$OSM_DEVOPS"' EXIT
712 git clone https://osm.etsi.org/gerrit/osm/devops.git $OSM_DEVOPS
713 fi
714 fi
715}
716
717function install_osm() {
718 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
719
720 trap ctrl_c INT
721
722 # TODO: move this under start
723 [ -n "$DOCKER_REGISTRY_URL" ] && parse_docker_registry_url
724
725 check_osm_behind_proxy
726 track checks proxy_ok
727
728 check_packages "git wget curl tar snapd"
729
730 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
731
732 find_devops_folder
733
garciadeblasfa3eb332022-11-15 14:11:56 +0100734 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
735
736 track checks checkingroot_ok
737 [ "$USER" == "root" ] && FATAL "You are running the installer as root. The installer is prepared to be executed as a normal user with sudo privileges."
738 track checks noroot_ok
739
740 ask_proceed
garciadeblas4d89c372021-11-25 11:57:18 +0100741 track checks proceed_ok
vijaynag8339ed22019-07-25 17:10:58 +0530742
garciadeblas0bc87522021-10-20 22:16:17 +0200743 echo "Installing OSM"
744
745 echo "Determining IP address of the interface with the default route"
garciadeblas45ab04c2022-11-25 10:59:03 +0100746 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
747 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
748 [ -z "$OSM_DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
749 OSM_DEFAULT_IP=`ip -o -4 a s ${OSM_DEFAULT_IF} |awk '{split($4,a,"/"); print a[1]; exit}'`
750 [ -z "$OSM_DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
garciadeblas0bc87522021-10-20 22:16:17 +0200751
752 # configure apt proxy
753 [ -n "$APT_PROXY_URL" ] && configure_apt_proxy $APT_PROXY_URL
Mike Marchettib8420852018-09-13 13:45:06 -0400754
755 # if no host is passed in, we need to install lxd/juju, unless explicilty asked not to
David Garcia79f4f532020-04-07 12:59:34 +0200756 if [ -z "$OSM_VCA_HOST" ] && [ -z "$INSTALL_NOLXD" ] && [ -z "$LXD_CLOUD_FILE" ]; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100757 LXD_INSTALL_OPTS="-D ${OSM_DEVOPS} -i ${OSM_DEFAULT_IF} ${DEBUG_INSTALL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100758 [ -n "${OSM_BEHIND_PROXY}" ] && LXD_INSTALL_OPTS="${LXD_INSTALL_OPTS} -P"
garciadeblas8fed1082022-08-29 11:25:02 +0200759 $OSM_DEVOPS/installers/install_lxd.sh ${LXD_INSTALL_OPTS} || FATAL_TRACK lxd "install_lxd.sh failed"
garciadeblasd41f5482018-05-25 10:25:06 +0200760 fi
David Garcia79f4f532020-04-07 12:59:34 +0200761
garciadeblas4d89c372021-11-25 11:57:18 +0100762 track prereq prereqok_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400763
garciadeblas95804f82021-11-08 23:02:01 +0100764 if [ ! -n "$INSTALL_NODOCKER" ]; then
765 DOCKER_CE_OPTS="-D ${OSM_DEVOPS} ${DEBUG_INSTALL}"
766 [ -n "${DOCKER_PROXY_URL}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -p ${DOCKER_PROXY_URL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100767 [ -n "${OSM_BEHIND_PROXY}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100768 $OSM_DEVOPS/installers/install_docker_ce.sh ${DOCKER_CE_OPTS} || FATAL_TRACK docker_ce "install_docker_ce.sh failed"
garciadeblas95804f82021-11-08 23:02:01 +0100769 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200770
garciadeblas4d89c372021-11-25 11:57:18 +0100771 track docker_ce docker_ce_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200772
773 echo "Creating folders for installation"
garciadeblas0bc87522021-10-20 22:16:17 +0200774 [ ! -d "$OSM_DOCKER_WORK_DIR" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR
775 [ ! -d "$OSM_DOCKER_WORK_DIR/osm_pla" -a -n "$INSTALL_PLA" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR/osm_pla
776 sudo cp -b $OSM_DEVOPS/installers/docker/cluster-config.yaml $OSM_DOCKER_WORK_DIR/cluster-config.yaml
David Garcia6cbfee12020-10-23 10:40:20 +0200777
garciadeblas45ab04c2022-11-25 10:59:03 +0100778 $OSM_DEVOPS/installers/install_kubeadm_cluster.sh -i ${OSM_DEFAULT_IP} -d ${OSM_DOCKER_WORK_DIR} -D ${OSM_DEVOPS} ${DEBUG_INSTALL} || \
garciadeblas4d89c372021-11-25 11:57:18 +0100779 FATAL_TRACK k8scluster "install_kubeadm_cluster.sh failed"
780 track k8scluster k8scluster_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200781
garciadeblas325032a2023-04-13 18:07:44 +0200782 JUJU_OPTS="-D ${OSM_DEVOPS} -s ${OSM_NAMESPACE} -i ${OSM_DEFAULT_IP} ${DEBUG_INSTALL} ${INSTALL_NOJUJU} ${INSTALL_CACHELXDIMAGES}"
garciadeblas0bc87522021-10-20 22:16:17 +0200783 [ -n "${OSM_VCA_HOST}" ] && JUJU_OPTS="$JUJU_OPTS -H ${OSM_VCA_HOST}"
784 [ -n "${LXD_CLOUD_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -l ${LXD_CLOUD_FILE}"
785 [ -n "${LXD_CRED_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -L ${LXD_CRED_FILE}"
786 [ -n "${CONTROLLER_NAME}" ] && JUJU_OPTS="$JUJU_OPTS -K ${CONTROLLER_NAME}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100787 [ -n "${OSM_BEHIND_PROXY}" ] && JUJU_OPTS="${JUJU_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100788 $OSM_DEVOPS/installers/install_juju.sh ${JUJU_OPTS} || FATAL_TRACK juju "install_juju.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200789 set_vca_variables
garciadeblas4d89c372021-11-25 11:57:18 +0100790 track juju juju_ok
Adam Israel5ddc97f2019-09-03 18:11:12 -0400791
Benjamin Diazba2cca92018-11-08 21:07:15 -0300792 if [ -z "$OSM_DATABASE_COMMONKEY" ]; then
793 OSM_DATABASE_COMMONKEY=$(generate_secret)
794 [ -z "OSM_DATABASE_COMMONKEY" ] && FATAL "Cannot generate common db secret"
795 fi
vijaynag8339ed22019-07-25 17:10:58 +0530796
David Garcia6cbfee12020-10-23 10:40:20 +0200797 # Deploy OSM services
garciadeblas53b217f2023-05-04 17:57:47 +0200798 [ -z "$DOCKER_NOBUILD" ] && pull_docker_images
799 [ -z "$DOCKER_NOBUILD" ] && [ -z "$PULL_IMAGES" ] && generate_docker_images
garciadeblas4d89c372021-11-25 11:57:18 +0100800 track docker_images docker_images_ok
vijaynag8339ed22019-07-25 17:10:58 +0530801
garciadeblas0bc87522021-10-20 22:16:17 +0200802 generate_k8s_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100803 track osm_files manifest_files_ok
garciadeblasd8bc5c32018-05-09 17:37:56 +0200804 generate_docker_env_files
garciadeblas4d89c372021-11-25 11:57:18 +0100805 track osm_files env_files_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400806
garciadeblas0bc87522021-10-20 22:16:17 +0200807 deploy_charmed_services
garciadeblas4d89c372021-11-25 11:57:18 +0100808 track deploy_osm deploy_charmed_services_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200809 kube_secrets
garciadeblas4d89c372021-11-25 11:57:18 +0100810 track deploy_osm kube_secrets_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200811 update_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100812 track deploy_osm update_manifest_files_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200813 namespace_vol
garciadeblas4d89c372021-11-25 11:57:18 +0100814 track deploy_osm namespace_vol_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200815 deploy_osm_services
garciadeblas4d89c372021-11-25 11:57:18 +0100816 track deploy_osm deploy_osm_services_k8s_ok
garciadeblas7b53d262022-11-04 23:18:48 +0100817 if [ -n "$INSTALL_PLA" ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200818 # optional PLA install
819 deploy_osm_pla_service
garciadeblas4d89c372021-11-25 11:57:18 +0100820 track deploy_osm deploy_osm_pla_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200821 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200822 if [ -n "$INSTALL_K8S_MONITOR" ]; then
823 # install OSM MONITORING
824 install_k8s_monitoring
garciadeblas4d89c372021-11-25 11:57:18 +0100825 track deploy_osm install_k8s_monitoring_ok
vijaynag8339ed22019-07-25 17:10:58 +0530826 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100827 if [ -n "$INSTALL_NGSA" ]; then
828 # optional PLA install
829 install_osm_ngsa_service
830 track deploy_osm install_osm_ngsa_ok
831 fi
vijaynag8339ed22019-07-25 17:10:58 +0530832
Mike Marchettib8420852018-09-13 13:45:06 -0400833 [ -z "$INSTALL_NOHOSTCLIENT" ] && install_osmclient
garciadeblas4d89c372021-11-25 11:57:18 +0100834 track osmclient osmclient_ok
beierlma4a37f72020-06-26 12:55:01 -0400835
garciadeblas4a9adcd2020-07-03 15:32:05 +0000836 echo -e "Checking OSM health state..."
garciadeblas325032a2023-04-13 18:07:44 +0200837 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_NAMESPACE} -k || \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100838 (echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
garciadeblas325032a2023-04-13 18:07:44 +0200839 echo -e "Check OSM status with: kubectl -n ${OSM_NAMESPACE} get all" && \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100840 track healthchecks osm_unhealthy didnotconverge)
garciadeblas4d89c372021-11-25 11:57:18 +0100841 track healthchecks after_healthcheck_ok
vijaynag8339ed22019-07-25 17:10:58 +0530842
garciadeblas0bc87522021-10-20 22:16:17 +0200843 add_local_k8scluster
garciadeblas4d89c372021-11-25 11:57:18 +0100844 track final_ops add_local_k8scluster_ok
garciadeblase92a18d2020-07-03 16:24:23 +0000845
Gulsum Atici3d3a7672023-02-01 11:15:52 +0300846 arrange_docker_default_network_policy
Gulsum Atici5e263302023-01-30 19:11:31 +0300847
garciadeblas89c5f552022-11-24 20:16:57 +0100848 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
garciadeblas6c66abf2018-05-16 14:46:19 +0200849 track end
garciadeblas0bc87522021-10-20 22:16:17 +0200850 sudo find /etc/osm
851 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200852 return 0
853}
854
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200855function install_to_openstack() {
garciadeblas0bc87522021-10-20 22:16:17 +0200856 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200857
858 if [ -z "$2" ]; then
859 FATAL "OpenStack installer requires a valid external network name"
860 fi
861
862 # Install Pip for Python3
garciadeblas0bc87522021-10-20 22:16:17 +0200863 sudo apt install -y python3-pip python3-venv
864 sudo -H LC_ALL=C python3 -m pip install -U pip
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200865
Antonio Marsico75a38c72020-12-21 17:29:42 +0100866 # Create a venv to avoid conflicts with the host installation
867 python3 -m venv $OPENSTACK_PYTHON_VENV
868
869 source $OPENSTACK_PYTHON_VENV/bin/activate
870
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100871 # Install Ansible, OpenStack client and SDK, latest openstack version supported is Train
Antonio Marsico75a38c72020-12-21 17:29:42 +0100872 python -m pip install -U wheel
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100873 python -m pip install -U "python-openstackclient<=4.0.2" "openstacksdk>=0.12.0,<=0.36.2" "ansible>=2.10,<2.11"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100874
875 # Install the Openstack cloud module (ansible>=2.10)
876 ansible-galaxy collection install openstack.cloud
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200877
878 export ANSIBLE_CONFIG="$OSM_DEVOPS/installers/openstack/ansible.cfg"
879
880 OSM_INSTALLER_ARGS="${REPO_ARGS[@]}"
881
Antonio Marsico75a38c72020-12-21 17:29:42 +0100882 ANSIBLE_VARS="external_network_name=$2 setup_volume=$3 server_name=$OPENSTACK_VM_NAME"
883
884 if [ -n "$OPENSTACK_SSH_KEY_FILE" ]; then
885 ANSIBLE_VARS+=" key_file=$OPENSTACK_SSH_KEY_FILE"
886 fi
887
888 if [ -n "$OPENSTACK_USERDATA_FILE" ]; then
889 ANSIBLE_VARS+=" userdata_file=$OPENSTACK_USERDATA_FILE"
890 fi
891
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200892 # Execute the Ansible playbook based on openrc or clouds.yaml
893 if [ -e "$1" ]; then
894 . $1
Antonio Marsico75a38c72020-12-21 17:29:42 +0100895 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
896 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200897 else
Antonio Marsico75a38c72020-12-21 17:29:42 +0100898 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
899 -e cloud_name=$1 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200900 fi
901
Antonio Marsico75a38c72020-12-21 17:29:42 +0100902 # Exit from venv
903 deactivate
904
garciadeblas0bc87522021-10-20 22:16:17 +0200905 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200906 return 0
907}
908
Gulsum Atici3d3a7672023-02-01 11:15:52 +0300909function arrange_docker_default_network_policy() {
910 echo -e "Fixing firewall so docker and LXD can share the same host without affecting each other."
911 sudo iptables -I DOCKER-USER -j ACCEPT
912 sudo iptables-save | sudo tee /etc/iptables/rules.v4
913 sudo ip6tables-save | sudo tee /etc/iptables/rules.v6
914}
915
romeromonsere366b1a2019-11-19 19:49:26 +0100916function install_k8s_monitoring() {
garciadeblas0bc87522021-10-20 22:16:17 +0200917 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
romeromonsere366b1a2019-11-19 19:49:26 +0100918 # install OSM monitoring
garciadeblas0bc87522021-10-20 22:16:17 +0200919 sudo chmod +x $OSM_DEVOPS/installers/k8s/*.sh
garciadeblas4d89c372021-11-25 11:57:18 +0100920 sudo $OSM_DEVOPS/installers/k8s/install_osm_k8s_monitoring.sh || FATAL_TRACK install_k8s_monitoring "k8s/install_osm_k8s_monitoring.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200921 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonsere366b1a2019-11-19 19:49:26 +0100922}
923
garciadeblasd8bc5c32018-05-09 17:37:56 +0200924function dump_vars(){
garciadeblas0bc87522021-10-20 22:16:17 +0200925 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
926 echo "APT_PROXY_URL=$APT_PROXY_URL"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200927 echo "DEVELOP=$DEVELOP"
garciadeblas0bc87522021-10-20 22:16:17 +0200928 echo "DEBUG_INSTALL=$DEBUG_INSTALL"
929 echo "DOCKER_NOBUILD=$DOCKER_NOBUILD"
930 echo "DOCKER_PROXY_URL=$DOCKER_PROXY_URL"
931 echo "DOCKER_REGISTRY_URL=$DOCKER_REGISTRY_URL"
932 echo "DOCKER_USER=$DOCKER_USER"
933 echo "INSTALL_CACHELXDIMAGES=$INSTALL_CACHELXDIMAGES"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200934 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
garciadeblas0bc87522021-10-20 22:16:17 +0200935 echo "INSTALL_K8S_MONITOR=$INSTALL_K8S_MONITOR"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200936 echo "INSTALL_LIGHTWEIGHT=$INSTALL_LIGHTWEIGHT"
garciadeblas0bc87522021-10-20 22:16:17 +0200937 echo "INSTALL_LXD=$INSTALL_LXD"
garciadeblas7b53d262022-11-04 23:18:48 +0100938 echo "INSTALL_NGSA=$INSTALL_NGSA"
garciadeblas0bc87522021-10-20 22:16:17 +0200939 echo "INSTALL_NODOCKER=$INSTALL_NODOCKER"
940 echo "INSTALL_NOJUJU=$INSTALL_NOJUJU"
941 echo "INSTALL_NOLXD=$INSTALL_NOLXD"
garciadeblas6c66abf2018-05-16 14:46:19 +0200942 echo "INSTALL_ONLY=$INSTALL_ONLY"
garciadeblas0bc87522021-10-20 22:16:17 +0200943 echo "INSTALL_PLA=$INSTALL_PLA"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200944 echo "INSTALL_TO_OPENSTACK=$INSTALL_TO_OPENSTACK"
garciadeblas0bc87522021-10-20 22:16:17 +0200945 echo "INSTALL_VIMEMU=$INSTALL_VIMEMU"
946 echo "NO_HOST_PORTS=$NO_HOST_PORTS"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200947 echo "OPENSTACK_PUBLIC_NET_NAME=$OPENSTACK_PUBLIC_NET_NAME"
948 echo "OPENSTACK_OPENRC_FILE_OR_CLOUD=$OPENSTACK_OPENRC_FILE_OR_CLOUD"
949 echo "OPENSTACK_ATTACH_VOLUME=$OPENSTACK_ATTACH_VOLUME"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100950 echo "OPENSTACK_SSH_KEY_FILE"="$OPENSTACK_SSH_KEY_FILE"
951 echo "OPENSTACK_USERDATA_FILE"="$OPENSTACK_USERDATA_FILE"
952 echo "OPENSTACK_VM_NAME"="$OPENSTACK_VM_NAME"
garciadeblas0bc87522021-10-20 22:16:17 +0200953 echo "OSM_DEVOPS=$OSM_DEVOPS"
954 echo "OSM_DOCKER_TAG=$OSM_DOCKER_TAG"
garciadeblas0cd9b882022-02-10 03:11:50 +0100955 echo "OSM_DOCKER_WORK_DIR=$OSM_DOCKER_WORK_DIR"
garciadeblas7b53d262022-11-04 23:18:48 +0100956 echo "OSM_HELM_WORK_DIR=$OSM_HELM_WORK_DIR"
garciadeblas0cd9b882022-02-10 03:11:50 +0100957 echo "OSM_K8S_WORK_DIR=$OSM_K8S_WORK_DIR"
garciadeblas325032a2023-04-13 18:07:44 +0200958 echo "OSM_NAMESPACE=$OSM_NAMESPACE"
garciadeblas0bc87522021-10-20 22:16:17 +0200959 echo "OSM_VCA_HOST=$OSM_VCA_HOST"
960 echo "OSM_VCA_PUBKEY=$OSM_VCA_PUBKEY"
961 echo "OSM_VCA_SECRET=$OSM_VCA_SECRET"
962 echo "OSM_WORK_DIR=$OSM_WORK_DIR"
963 echo "PULL_IMAGES=$PULL_IMAGES"
964 echo "RECONFIGURE=$RECONFIGURE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200965 echo "RELEASE=$RELEASE"
966 echo "REPOSITORY=$REPOSITORY"
967 echo "REPOSITORY_BASE=$REPOSITORY_BASE"
968 echo "REPOSITORY_KEY=$REPOSITORY_KEY"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200969 echo "SHOWOPTS=$SHOWOPTS"
garciadeblas0bc87522021-10-20 22:16:17 +0200970 echo "TEST_INSTALLER=$TEST_INSTALLER"
971 echo "TO_REBUILD=$TO_REBUILD"
972 echo "UNINSTALL=$UNINSTALL"
973 echo "UPDATE=$UPDATE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200974 echo "Install from specific refspec (-b): $COMMIT_ID"
garciadeblas0bc87522021-10-20 22:16:17 +0200975 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200976}
977
garciadeblas453d4582020-12-16 19:03:10 +0100978function parse_docker_registry_url() {
garciadeblas0bc87522021-10-20 22:16:17 +0200979 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100980 DOCKER_REGISTRY_USER=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[1]}')
981 DOCKER_REGISTRY_PASSWORD=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[2]}')
982 DOCKER_REGISTRY_URL=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); print a[2]}')
garciadeblas0bc87522021-10-20 22:16:17 +0200983 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100984}
985
garciadeblasadcf95e2022-01-28 17:15:39 +0100986function ctrl_c() {
987 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
988 echo "** Trapped CTRL-C"
989 FATAL "User stopped the installation"
990 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
991}
992
garciadeblasd8bc5c32018-05-09 17:37:56 +0200993UNINSTALL=""
994DEVELOP=""
garciadeblasd8bc5c32018-05-09 17:37:56 +0200995UPDATE=""
996RECONFIGURE=""
997TEST_INSTALLER=""
998INSTALL_LXD=""
999SHOWOPTS=""
1000COMMIT_ID=""
1001ASSUME_YES=""
garciadeblas0bc87522021-10-20 22:16:17 +02001002APT_PROXY_URL=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001003INSTALL_FROM_SOURCE=""
garciadeblas0bc87522021-10-20 22:16:17 +02001004DEBUG_INSTALL=""
garciadeblas00627272021-05-26 16:54:05 +02001005RELEASE="ReleaseTEN"
Mike Marchettib8420852018-09-13 13:45:06 -04001006REPOSITORY="stable"
garciadeblasfa3eb332022-11-15 14:11:56 +01001007INSTALL_K8S_MONITOR=""
garciadeblas836354f2023-05-10 18:12:00 +02001008INSTALL_NGSA="y"
garciadeblasfa3eb332022-11-15 14:11:56 +01001009INSTALL_PLA=""
1010INSTALL_VIMEMU=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001011LXD_REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/lxd"
1012LXD_REPOSITORY_PATH=""
1013INSTALL_LIGHTWEIGHT="y"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001014INSTALL_TO_OPENSTACK=""
1015OPENSTACK_OPENRC_FILE_OR_CLOUD=""
1016OPENSTACK_PUBLIC_NET_NAME=""
1017OPENSTACK_ATTACH_VOLUME="false"
Antonio Marsico75a38c72020-12-21 17:29:42 +01001018OPENSTACK_SSH_KEY_FILE=""
1019OPENSTACK_USERDATA_FILE=""
1020OPENSTACK_VM_NAME="server-osm"
1021OPENSTACK_PYTHON_VENV="$HOME/.virtual-envs/osm"
garciadeblas6c66abf2018-05-16 14:46:19 +02001022INSTALL_ONLY=""
garciadeblas0e596bc2018-05-28 16:04:42 +02001023TO_REBUILD=""
garciadeblasd41f5482018-05-25 10:25:06 +02001024INSTALL_NOLXD=""
garciadeblasa3e26612018-05-30 17:58:55 +02001025INSTALL_NODOCKER=""
Mike Marchettib8420852018-09-13 13:45:06 -04001026INSTALL_NOJUJU=""
garciadeblas0d45bc82018-11-19 14:25:13 +01001027INSTALL_NOHOSTCLIENT=""
garciadeblas0bc87522021-10-20 22:16:17 +02001028INSTALL_CACHELXDIMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001029OSM_DEVOPS=
lavadoe07b1642018-10-25 10:58:34 -05001030OSM_VCA_HOST=
1031OSM_VCA_SECRET=
garciadeblasaa3ddf42019-04-04 19:04:32 +02001032OSM_VCA_PUBKEY=
David Garcia79f4f532020-04-07 12:59:34 +02001033OSM_VCA_CLOUDNAME="localhost"
beierlma4a37f72020-06-26 12:55:01 -04001034OSM_VCA_K8S_CLOUDNAME="k8scloud"
garciadeblas325032a2023-04-13 18:07:44 +02001035OSM_NAMESPACE=osm
Mike Marchettib8420852018-09-13 13:45:06 -04001036NO_HOST_PORTS=""
1037DOCKER_NOBUILD=""
1038REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
garciadeblas870e60a2018-11-21 16:44:21 +01001039REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/debian"
Mike Marchettib8420852018-09-13 13:45:06 -04001040OSM_WORK_DIR="/etc/osm"
garciadeblas7b53d262022-11-04 23:18:48 +01001041OSM_DOCKER_WORK_DIR="${OSM_WORK_DIR}/docker"
vijaynag8339ed22019-07-25 17:10:58 +05301042OSM_K8S_WORK_DIR="${OSM_DOCKER_WORK_DIR}/osm_pods"
garciadeblas7b53d262022-11-04 23:18:48 +01001043OSM_HELM_WORK_DIR="${OSM_WORK_DIR}/helm"
vijaynag8339ed22019-07-25 17:10:58 +05301044OSM_HOST_VOL="/var/lib/osm"
garciadeblas325032a2023-04-13 18:07:44 +02001045OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_NAMESPACE}"
Mike Marchetti13d76c82018-09-19 15:00:36 -04001046OSM_DOCKER_TAG=latest
garciadeblas0d45bc82018-11-19 14:25:13 +01001047DOCKER_USER=opensourcemano
1048PULL_IMAGES="y"
Benjamin Diazaa0af712018-10-04 14:02:34 -03001049KAFKA_TAG=2.11-1.0.2
garciadeblas0ab16612022-02-22 14:23:57 +01001050KIWIGRID_K8S_SIDECAR_TAG="1.15.6"
1051PROMETHEUS_TAG=v2.28.1
1052GRAFANA_TAG=8.1.1
lavado6ad812e2019-11-29 10:58:58 -05001053PROMETHEUS_NODE_EXPORTER_TAG=0.18.1
1054PROMETHEUS_CADVISOR_TAG=latest
lavado9a8df7c2018-10-24 09:35:34 -05001055KEYSTONEDB_TAG=10
Benjamin Diazba2cca92018-11-08 21:07:15 -03001056OSM_DATABASE_COMMONKEY=
lavado53eb8f52018-11-16 12:58:23 -05001057ELASTIC_VERSION=6.4.2
lavado4e8662c2018-11-28 11:28:14 -05001058ELASTIC_CURATOR_VERSION=5.5.4
vijaynag8339ed22019-07-25 17:10:58 +05301059POD_NETWORK_CIDR=10.244.0.0/16
1060K8S_MANIFEST_DIR="/etc/kubernetes/manifests"
1061RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
garciadeblas7f1e1042020-11-30 14:07:03 +00001062DOCKER_REGISTRY_URL=
1063DOCKER_PROXY_URL=
1064MODULE_DOCKER_TAG=
garciadeblas4d89c372021-11-25 11:57:18 +01001065OSM_INSTALLATION_TYPE="Default"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001066
garciadeblas0bc87522021-10-20 22:16:17 +02001067while getopts ":a:b:r:n:k:u:R:D:o:O:m:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:-: hy" o; do
garciadeblasd8bc5c32018-05-09 17:37:56 +02001068 case "${o}" in
garciadeblas0bc87522021-10-20 22:16:17 +02001069 a)
1070 APT_PROXY_URL=${OPTARG}
1071 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001072 b)
1073 COMMIT_ID=${OPTARG}
garciadeblas0d45bc82018-11-19 14:25:13 +01001074 PULL_IMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001075 ;;
1076 r)
Mike Marchettib8420852018-09-13 13:45:06 -04001077 REPOSITORY="${OPTARG}"
1078 REPO_ARGS+=(-r "$REPOSITORY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001079 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001080 k)
Mike Marchettib8420852018-09-13 13:45:06 -04001081 REPOSITORY_KEY="${OPTARG}"
1082 REPO_ARGS+=(-k "$REPOSITORY_KEY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001083 ;;
1084 u)
Mike Marchettib8420852018-09-13 13:45:06 -04001085 REPOSITORY_BASE="${OPTARG}"
1086 REPO_ARGS+=(-u "$REPOSITORY_BASE")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001087 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001088 R)
1089 RELEASE="${OPTARG}"
1090 REPO_ARGS+=(-R "$RELEASE")
garciadeblas0d45bc82018-11-19 14:25:13 +01001091 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001092 D)
1093 OSM_DEVOPS="${OPTARG}"
1094 ;;
garciadeblas6c66abf2018-05-16 14:46:19 +02001095 o)
1096 INSTALL_ONLY="y"
garciadeblasb5a630f2020-03-05 18:32:16 +00001097 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblasfa3eb332022-11-15 14:11:56 +01001098 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
garciadeblas6c66abf2018-05-16 14:46:19 +02001099 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001100 O)
1101 INSTALL_TO_OPENSTACK="y"
1102 if [ -n "${OPTARG}" ]; then
1103 OPENSTACK_OPENRC_FILE_OR_CLOUD="${OPTARG}"
1104 else
1105 echo -e "Invalid argument for -O : ' $OPTARG'\n" >&2
1106 usage && exit 1
1107 fi
1108 ;;
Antonio Marsico75a38c72020-12-21 17:29:42 +01001109 f)
1110 OPENSTACK_SSH_KEY_FILE="${OPTARG}"
1111 ;;
1112 F)
1113 OPENSTACK_USERDATA_FILE="${OPTARG}"
1114 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001115 N)
1116 OPENSTACK_PUBLIC_NET_NAME="${OPTARG}"
1117 ;;
garciadeblas0e596bc2018-05-28 16:04:42 +02001118 m)
garciadeblas7f1e1042020-11-30 14:07:03 +00001119 [ "${OPTARG}" == "NG-UI" ] && TO_REBUILD="$TO_REBUILD NG-UI" && continue
govindappa79e51b92019-05-22 12:15:21 +05301120 [ "${OPTARG}" == "NBI" ] && TO_REBUILD="$TO_REBUILD NBI" && continue
1121 [ "${OPTARG}" == "LCM" ] && TO_REBUILD="$TO_REBUILD LCM" && continue
1122 [ "${OPTARG}" == "RO" ] && TO_REBUILD="$TO_REBUILD RO" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001123 [ "${OPTARG}" == "MON" ] && TO_REBUILD="$TO_REBUILD MON" && continue
govindappa79e51b92019-05-22 12:15:21 +05301124 [ "${OPTARG}" == "POL" ] && TO_REBUILD="$TO_REBUILD POL" && continue
garciadeblas7f1e1042020-11-30 14:07:03 +00001125 [ "${OPTARG}" == "PLA" ] && TO_REBUILD="$TO_REBUILD PLA" && continue
1126 [ "${OPTARG}" == "osmclient" ] && TO_REBUILD="$TO_REBUILD osmclient" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001127 [ "${OPTARG}" == "KAFKA" ] && TO_REBUILD="$TO_REBUILD KAFKA" && continue
1128 [ "${OPTARG}" == "MONGO" ] && TO_REBUILD="$TO_REBUILD MONGO" && continue
govindappa79e51b92019-05-22 12:15:21 +05301129 [ "${OPTARG}" == "PROMETHEUS" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS" && continue
garciadeblasfc5bb142019-12-10 10:49:12 +01001130 [ "${OPTARG}" == "PROMETHEUS-CADVISOR" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS-CADVISOR" && continue
govindappa79e51b92019-05-22 12:15:21 +05301131 [ "${OPTARG}" == "KEYSTONE-DB" ] && TO_REBUILD="$TO_REBUILD KEYSTONE-DB" && continue
lavado6ad812e2019-11-29 10:58:58 -05001132 [ "${OPTARG}" == "GRAFANA" ] && TO_REBUILD="$TO_REBUILD GRAFANA" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001133 [ "${OPTARG}" == "NONE" ] && TO_REBUILD="$TO_REBUILD NONE" && continue
1134 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001135 H)
1136 OSM_VCA_HOST="${OPTARG}"
1137 ;;
1138 S)
1139 OSM_VCA_SECRET="${OPTARG}"
1140 ;;
1141 s)
garciadeblas325032a2023-04-13 18:07:44 +02001142 OSM_NAMESPACE="${OPTARG}" && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
garciadeblas25e87d22020-01-31 14:27:29 +01001143 ;;
1144 t)
1145 OSM_DOCKER_TAG="${OPTARG}"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001146 REPO_ARGS+=(-t "$OSM_DOCKER_TAG")
garciadeblas25e87d22020-01-31 14:27:29 +01001147 ;;
1148 U)
1149 DOCKER_USER="${OPTARG}"
1150 ;;
1151 P)
1152 OSM_VCA_PUBKEY=$(cat ${OPTARG})
1153 ;;
1154 A)
1155 OSM_VCA_APIPROXY="${OPTARG}"
1156 ;;
David Garcia79f4f532020-04-07 12:59:34 +02001157 l)
1158 LXD_CLOUD_FILE="${OPTARG}"
1159 ;;
1160 L)
1161 LXD_CRED_FILE="${OPTARG}"
1162 ;;
David Garcia404ae122020-04-28 11:47:55 +02001163 K)
1164 CONTROLLER_NAME="${OPTARG}"
1165 ;;
garciadeblas7f1e1042020-11-30 14:07:03 +00001166 d)
1167 DOCKER_REGISTRY_URL="${OPTARG}"
1168 ;;
1169 p)
1170 DOCKER_PROXY_URL="${OPTARG}"
1171 ;;
1172 T)
1173 MODULE_DOCKER_TAG="${OPTARG}"
1174 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001175 -)
1176 [ "${OPTARG}" == "help" ] && usage && exit 0
garciadeblas0d45bc82018-11-19 14:25:13 +01001177 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && PULL_IMAGES="" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001178 [ "${OPTARG}" == "debug" ] && DEBUG_INSTALL="--debug" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001179 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
1180 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001181 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
1182 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
1183 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
1184 [ "${OPTARG}" == "lxdinstall" ] && INSTALL_LXD="y" && continue
garciadeblasd41f5482018-05-25 10:25:06 +02001185 [ "${OPTARG}" == "nolxd" ] && INSTALL_NOLXD="y" && continue
garciadeblasa3e26612018-05-30 17:58:55 +02001186 [ "${OPTARG}" == "nodocker" ] && INSTALL_NODOCKER="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001187 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001188 [ "${OPTARG}" == "nohostports" ] && NO_HOST_PORTS="y" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001189 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="--nojuju" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001190 [ "${OPTARG}" == "nodockerbuild" ] && DOCKER_NOBUILD="y" && continue
1191 [ "${OPTARG}" == "nohostclient" ] && INSTALL_NOHOSTCLIENT="y" && continue
garciadeblas0d45bc82018-11-19 14:25:13 +01001192 [ "${OPTARG}" == "pullimages" ] && continue
garciadeblasb5a630f2020-03-05 18:32:16 +00001193 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblas4d89c372021-11-25 11:57:18 +01001194 [ "${OPTARG}" == "charmed" ] && CHARMED="y" && OSM_INSTALLATION_TYPE="Charmed" && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001195 [ "${OPTARG}" == "bundle" ] && continue
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +02001196 [ "${OPTARG}" == "k8s" ] && continue
1197 [ "${OPTARG}" == "lxd" ] && continue
1198 [ "${OPTARG}" == "lxd-cred" ] && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001199 [ "${OPTARG}" == "microstack" ] && continue
David Garcia4bd2bf02021-05-05 19:01:43 +02001200 [ "${OPTARG}" == "overlay" ] && continue
David Garcia1bc71022021-05-03 18:27:18 +02001201 [ "${OPTARG}" == "only-vca" ] && continue
aticig5d19ac22022-05-06 13:46:22 +03001202 [ "${OPTARG}" == "small-profile" ] && continue
Dominik Fleischmannc63bed62020-09-25 12:17:54 +02001203 [ "${OPTARG}" == "vca" ] && continue
Dominik Fleischmannc57296f2020-06-09 11:45:08 +02001204 [ "${OPTARG}" == "ha" ] && continue
David Garcia69388c22020-05-07 12:14:19 +02001205 [ "${OPTARG}" == "tag" ] && continue
beierlmf2782c52020-11-05 17:04:05 -05001206 [ "${OPTARG}" == "registry" ] && continue
magnussonl1bbe9452020-02-25 13:43:17 +01001207 [ "${OPTARG}" == "pla" ] && INSTALL_PLA="y" && continue
garciadeblas836354f2023-05-10 18:12:00 +02001208 [ "${OPTARG}" == "old-sa" ] && INSTALL_NGSA="" && continue
garciadeblas7b53d262022-11-04 23:18:48 +01001209 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001210 [ "${OPTARG}" == "volume" ] && OPENSTACK_ATTACH_VOLUME="true" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001211 [ "${OPTARG}" == "nocachelxdimages" ] && continue
1212 [ "${OPTARG}" == "cachelxdimages" ] && INSTALL_CACHELXDIMAGES="--cachelxdimages" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001213 echo -e "Invalid option: '--$OPTARG'\n" >&2
1214 usage && exit 1
1215 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001216 :)
1217 echo "Option -$OPTARG requires an argument" >&2
1218 usage && exit 1
1219 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001220 \?)
1221 echo -e "Invalid option: '-$OPTARG'\n" >&2
1222 usage && exit 1
1223 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001224 h)
1225 usage && exit 0
1226 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001227 y)
1228 ASSUME_YES="y"
1229 ;;
1230 *)
1231 usage && exit 1
1232 ;;
1233 esac
1234done
1235
garciadeblas0bc87522021-10-20 22:16:17 +02001236source $OSM_DEVOPS/common/all_funcs
garciadeblas6c66abf2018-05-16 14:46:19 +02001237
garciadeblas0bc87522021-10-20 22:16:17 +02001238[ -z "${DEBUG_INSTALL}" ] || DEBUG Debug is on
1239[ -n "$SHOWOPTS" ] && dump_vars && exit 0
1240
1241# Uninstall if "--uninstall"
1242if [ -n "$UNINSTALL" ]; then
1243 if [ -n "$CHARMED" ]; then
garciadeblas4d89c372021-11-25 11:57:18 +01001244 ${OSM_DEVOPS}/installers/charmed_uninstall.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $OSM_DEVOPS -t $DOCKER_TAG "$@" || \
1245 FATAL_TRACK charmed_uninstall "charmed_uninstall.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001246 else
garciadeblas4d89c372021-11-25 11:57:18 +01001247 ${OSM_DEVOPS}/installers/uninstall_osm.sh "$@" || \
1248 FATAL_TRACK community_uninstall "uninstall_osm.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001249 fi
1250 echo -e "\nDONE"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001251 exit 0
1252fi
1253
garciadeblas0bc87522021-10-20 22:16:17 +02001254# Charmed installation
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001255if [ -n "$CHARMED" ]; then
Mark Beierl70d6f3a2022-12-12 09:00:59 -05001256 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
beierlmce7b4602022-04-13 08:19:40 -04001257 export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
1258 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
1259 ${OSM_DEVOPS}/installers/charmed_install.sh --tag $OSM_DOCKER_TAG "$@" || \
garciadeblas4d89c372021-11-25 11:57:18 +01001260 FATAL_TRACK charmed_install "charmed_install.sh failed"
garciadeblas89c5f552022-11-24 20:16:57 +01001261 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
beierlmce7b4602022-04-13 08:19:40 -04001262 track end installation_type $OSM_INSTALLATION_TYPE
garciadeblas0bc87522021-10-20 22:16:17 +02001263 echo -e "\nDONE"
1264 exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001265fi
1266
garciadeblas0bc87522021-10-20 22:16:17 +02001267# Installation to Openstack
1268if [ -n "$INSTALL_TO_OPENSTACK" ]; then
1269 install_to_openstack $OPENSTACK_OPENRC_FILE_OR_CLOUD $OPENSTACK_PUBLIC_NET_NAME $OPENSTACK_ATTACH_VOLUME
1270 echo -e "\nDONE"
1271 exit 0
1272fi
1273
1274# Community_installer
garciadeblasfa3eb332022-11-15 14:11:56 +01001275
garciadeblas0bc87522021-10-20 22:16:17 +02001276[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" != " NONE" ] && echo $TO_REBUILD | grep -q NONE && FATAL "Incompatible option: -m NONE cannot be used with other -m options"
1277[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" == " PLA" ] && [ -z "$INSTALL_PLA" ] && FATAL "Incompatible option: -m PLA cannot be used without --pla option"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001278# if develop, we force master
1279[ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
garciadeblas325032a2023-04-13 18:07:44 +02001280OSM_K8S_WORK_DIR="$OSM_DOCKER_WORK_DIR/osm_pods" && OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_NAMESPACE}"
garciadeblasb5a630f2020-03-05 18:32:16 +00001281[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_K8S_MONITOR" ] && install_k8s_monitoring
garciadeblasfa3eb332022-11-15 14:11:56 +01001282[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_NGSA" ] && install_osm_ngsa_service
garciadeblas6c66abf2018-05-16 14:46:19 +02001283[ -n "$INSTALL_ONLY" ] && echo -e "\nDONE" && exit 0
garciadeblasd8bc5c32018-05-09 17:37:56 +02001284
1285#Installation starts here
garciadeblas89c5f552022-11-24 20:16:57 +01001286wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README.txt &> /dev/null
garciadeblas4d89c372021-11-25 11:57:18 +01001287export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
garciadeblas0bc87522021-10-20 22:16:17 +02001288install_osm
garciadeblasd8bc5c32018-05-09 17:37:56 +02001289echo -e "\nDONE"
garciadeblas4d89c372021-11-25 11:57:18 +01001290exit 0